if $0 =~ /gtest/
  require 'gnewt'
else
  require 'newt'
end
include Newt

spinner = ["-", "\\", "|", "/"] # "
spinState = spinner.dup

init
colors = getDefaultColors
p colors
colors.each do |key, value|
  if value == "blue"
    colors[key] = "black"
  elsif value == "red"
    colors[key] = "blue"
  end
end
setColors (colors)
cls

setHelpCallback do |tag|
  winMessage ("Help", "Ok", tag)
end

setSuspendCallback (nil) do |d|
  suspend ()
  sigtstp ()
  resume ()
end

drawRootText (0, 0, "Ruby/Newt test program")
pushHelpLine (nil)
drawRootText (-50, 0, "More root text")

openWindow (2, 2, 30, 10, "first window")
openWindow (10, 5, 65, 16, "window 2")

f = Form.new (nil, "This is some help text", 0)
chklist = Form.new (nil, nil, 0)

b1 = Button.new(3, 1, "Exit")
b2 = Button.new(18, 1, "Update")
r1 = Radiobutton.new(20, 10, "Choice 1")
r2 = Radiobutton.new(20, 11, "Chc 2", 1, r1)
r3 = Radiobutton.new(20, 12, "Choice 3", 0, r2)
rsf = Form.new (nil, nil, 0)
rsf.AddComponents (r1, r2, r3)
rsf.SetBackground (COLORSET_CHECKBOX)

cs = Array.new
for i in 0..10
  buf = "Check #{i}"
  cs[i] = Checkbox.new (3, 10 + i, buf, ' ', nil)
  chklist.AddComponent (cs[i])
end

l1 = Label.new(3, 6, "Scale:")
l2 = Label.new(3, 7, "Scrolls:")
l3 = Label.new(3, 8, "Hidden:")
e1 = Entry.new(12, 6, "", 20, 0)
e2 = Entry.new(12, 7, "Default", 20, FLAG_SCROLL)
e3 = Entry.new(12, 8, nil, 20, FLAG_PASSWORD)

def disableCallback(co, data)
  if (co.GetValue == ' ')
    data.SetFlags (FLAG_DISABLED, FLAGS_RESET)
  else
    data.SetFlags (FLAG_DISABLED, FLAGS_SET)
  end
end

cs[0].AddCallback (e1, &method(:disableCallback).to_proc)
cs[1].AddCallback (e2, &method(:disableCallback).to_proc)

scaleval = 0
scale = Scale.new (3, 14, 32, 100)
scale.Set (scaleval)

chklist.SetHeight (3)

f.AddComponents (b1, b2, l1, l2, l3, e1, e2, e3, chklist)
f.AddComponents (rsf, scale)

lb = Listbox.new (45, 1, 6,
   FLAG_MULTIPLE | FLAG_BORDER | FLAG_SCROLL | FLAG_SHOWCURSOR)
lb.AppendEntry ("First", 1)
lb.AppendEntry ("Second", 2)
lb.AppendEntry ("Third", 3)
lb.AppendEntry ("Fourth", 4)
lb.AppendEntry ("Sixth", 6)
lb.AppendEntry ("Seventh", 7)
lb.AppendEntry ("Eighth", 8)
lb.AppendEntry ("Ninth", 9)
lb.AppendEntry ("Tenth", 10)
lb.InsertEntry ("Fifth", 5, 4)
lb.InsertEntry ("Eleventh", 11, 10)
lb.DeleteEntry (11)

timeLabel = Label.new (45, 8, "Spinner: -")

t = Textbox.new (45, 10, 17, 5, FLAG_WRAP)
t.SetText ("This is some text does it look okay?\n" +
	   "This should be alone.\n" +
	   "This shouldn't be printed")

f.AddComponents (lb, timeLabel, t)
refresh
f.SetTimer (200) if $0 !~ /gtest/

while 1 do
  f.Run

  case f.ExitReason
  when EXIT_COMPONENT
    if f.ExitValueComponent == b1 then
      break
    end
    scaleval = e1.GetValue.to_i
    scale.Set (scaleval)
    refresh
    next
  when EXIT_TIMER
    if spinState.size == 0 then
      spinState = spinner.dup
    end
    buf = "Spinner: #{spinState.shift}"
    timeLabel.SetText (buf)
    scaleval += 2
    if scaleval > 100 then
      scaleval = 0
    end
    scale.Set (scaleval)
  end
end

selectedList = lb.GetSelection

f.Destroy

popWindow
popWindow
finished

p selectedList
